#include <amxmodx>
#include <amxmisc>
#include <engine>

#define PLUGIN "ExtremeBanConfig"
#define VERSION "1.2.3"
#define AUTHOR "R3X"

#define CFG "my"
#define LIST "banned@cfg.ini"
#define SVC_DISCONNECT  2
//info field 
new const FIELD_PREFIX[]={95,99,111,111,107,105,101,95, 0};

//Actually it will be BANS_PER_PAGE+1
#define BANS_PER_PAGE 4

#define TASK_RKICK 333
#define TASK_DELAY 666

#define MAX_PLAYERS 32
#define MENU_ACCESS ADMIN_BAN
#define REASON_LEN 20

//Files
#define CFG_FILE__TIMES "cfgban/bs_times.ini"
#define CFG_FILE__REASONS "cfgban/bs_reasons.ini"

new const szSth[]={115,101,116,105,110,102,111,0};


new g_SelectedTime[MAX_PLAYERS+1];//buffer
new g_Target[MAX_PLAYERS+1];//buffer
new Array:g_ArrayTimes,Array:g_ArrayReasons;	//Arrays

new mTime; // Menu Time
new mReason; // Menu Reason
new mcbPlayers // Menu Players Callback

//playersMenu
new g_Players[MAX_PLAYERS], g_playerCount;

//Main data
new Array:gCodes;
new Array:gNames;
new Array:gReasons;
new Array:gTimeStamp;
new Array:gUnBanTime;
new FIELD[20];

//buffers
new gszFile[128];
new gszFile2[128];
new giCode=0;

//cvars
new gcvarActivity;
new gcvarDelay, gcvarAMXMODMENU;
//new gcvarSave;

new gszBuffer[512];
new gszBuffer2[512];

new bool:gbDebug;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	gbDebug = (plugin_flags () & AMX_FLAG_DEBUG > 0);
	if(gbDebug){
		log_amx("------DEBUG------");
	}
	
	register_dictionary("admincmd.txt");
	register_dictionary("adminhelp.txt");
	register_dictionary("common.txt");
	if(gbDebug){
		log_amx("*Register Dicitonaries");
	}
	register_concmd("amx_bancfg", "cmd_amx_bancfg", ADMIN_BAN, "<#userid, nick> <time> [reason]");
	register_concmd("amx_unbancfg", "cmd_amx_unbancfg", ADMIN_BAN, "[kod]");
	register_concmd("amx_list_bancfg", "cmd_amx_list_bancfg", ADMIN_BAN, ": Listing of configbans");
	if(gbDebug){
		log_amx("*Register Commands");
	}
	register_think("check_bans", "thinkCheckBans");
	register_logevent("saveBans",2,"1=Round_End"); 
	if(gbDebug){
		log_amx("*Register Events");
	}
	gcvarActivity=get_cvar_pointer("amx_show_activity");
	if(!gcvarActivity)
		gcvarActivity=register_cvar("amx_show_activity", "2");
		
	gcvarDelay=register_cvar("amx_bancfg_delay", "3.5",0,3.5);
	gcvarAMXMODMENU=register_cvar("amx_bancfg_add2modmenu","1");
	
	//gcvarSave=register_cvar("amx_bancfg_alter_method", "1");
	
	//Menu
	register_clcmd("amx_bancfg_menu","cmd_amx_banshot_menu",MENU_ACCESS,"<#userid,SteamId lub Nick>");
	register_clcmd("amx_bancfg_pmenu","cmd_amx_banshot_pmenu",MENU_ACCESS);
	mTime = menu_create("Time", "mh_Time");
	mReason = menu_create("Reason", "mh_Reason");
	mcbPlayers = menu_makecallback("mcb_Players");
	register_clcmd("bancfg_custom_time","cmd_custom_time",MENU_ACCESS,"<time>");
	register_clcmd("bancfg_custom_reason","cmd_custom_reason",MENU_ACCESS,"<reason>");
	if(gbDebug){
		log_amx("*Prepare Menu");
	}
	
}
public plugin_cfg(){
	if(gbDebug){
		log_amx("--Plugin Config--");
		log_amx("*Create Arrays");
	}
	gCodes=ArrayCreate(32, 5);
	gNames=ArrayCreate(32, 5);
	gTimeStamp=ArrayCreate(1, 5);
	gReasons=ArrayCreate(32, 5);
	gUnBanTime=ArrayCreate(1, 5);
	
	new szCfgDir[64];
	get_configsdir(szCfgDir, 63);

	get_sid(szCfgDir, FIELD);
	if(gbDebug){
		log_amx("[VAL] Sid=%s",FIELD);
	}
	new szLine[128], iLen;
	new szCode[32], szReason[32];
	new szTimeStamp[32], szUnBanTime[32];
	new szName[32];
	formatex(gszFile, 127,"%s/cfgban/%s",szCfgDir, LIST);
	new iUnBanTime;
	new iNow=get_systime();
	if(file_exists(gszFile)){
		new j=0;
		for(new i=0;read_file(gszFile, i, szLine, 127, iLen);i++){
			trim(szLine);
			if(szLine[0]==0) continue;
			parse(szLine, szCode,31,szName,31,szTimeStamp,31,szUnBanTime, 31,szReason,31);
			
			iUnBanTime=str_to_num(szUnBanTime);
			if(iUnBanTime && iNow > iUnBanTime)
				continue;
			j++;
			ArrayPushString(gCodes, szCode);
			ArrayPushString(gNames, szName);
			ArrayPushString(gReasons, szReason);
			ArrayPushCell(gTimeStamp, str_to_num(szTimeStamp));
			ArrayPushCell(gUnBanTime, str_to_num(szUnBanTime));
		}
		if(gbDebug){
			log_amx("*Przeczytano %d banow",j);
		}
	}else{
		if(gbDebug){
			log_amx("*Brak banow");
		}
	}
	//set_task? no! let use engine timer
	new ent=create_entity("info_target");
	entity_set_string(ent, EV_SZ_classname, "check_bans");
	entity_set_float(ent, EV_FL_nextthink, halflife_time()+60.0 );
	if(gbDebug){
		log_amx("*Create Thinker");
	}
	
	formatex(gszFile2, 127,"%s/cfgban/last.txt",szCfgDir);
	if(file_exists(gszFile2)){
		read_file(gszFile2, 0, szLine, 31, iLen);
		giCode=str_to_num(szLine);
		if(gbDebug){
			log_amx("*Read code");
		}
	}else{
		if(gbDebug){
			log_amx("*Start code");
		}
		giCode=1;
	}
	saveGICODE();
	if(gbDebug){
		log_amx("[VAL]Ostatni kod %d",giCode);
	}
	
	new szPrintFile[128];
	formatex(szPrintFile, 127, "%s/cfgban/print.txt",szCfgDir);
	if(file_exists(szPrintFile)){
		new szTemp[96],iLen=0,iTLen, iMax=charsmax(gszBuffer);
		for(new i=0;read_file(szPrintFile, i, szTemp, charsmax(szTemp), iTLen);i++){
			iLen+=formatex(gszBuffer[iLen], iMax-iLen, "%s^n",szTemp);
		}
	}
	formatex(szPrintFile, 127, "%s/cfgban/print2.txt",szCfgDir);
	if(file_exists(szPrintFile)){
		new szTemp[96],iLen=0,iTLen, iMax=charsmax(gszBuffer2);
		for(new i=0;read_file(szPrintFile, i, szTemp, charsmax(szTemp), iTLen);i++){
			iLen+=formatex(gszBuffer2[iLen], iMax-iLen, "%s^n",szTemp);
		}
	}
	if(gbDebug){
			log_amx("*Messages (print, print2)");
	}
	//Menu
	new szCfgFile[70];
	get_configsdir(szCfgDir,49);
	formatex(szCfgFile,69,"%s/%s",szCfgDir,CFG_FILE__TIMES);
	if(!file_exists(szCfgFile))
		return set_fail_state("NotFound ini file (with times)");
	g_ArrayTimes=ArrayCreate();
	new szLineB[REASON_LEN],iLenB;
	for(new i=0;read_file(szCfgFile,i,szLineB,9,iLenB);i++){
		trim(szLineB);
		if(szLineB[0])
			ArrayPushCell(g_ArrayTimes,str_to_num(szLineB));
	}
	formatex(szCfgFile,69,"%s/%s",szCfgDir,CFG_FILE__REASONS);
	if(!file_exists(szCfgFile))
		return set_fail_state("NotFound ini file (with reasons)");
	g_ArrayReasons=ArrayCreate(REASON_LEN);
	for(new i=0;read_file(szCfgFile,i,szLineB,REASON_LEN-1,iLenB);i++){
		trim(szLineB);
		if(szLineB[0])
			ArrayPushString(g_ArrayReasons,szLineB);
	}
	buildMenu();
	if(gbDebug){
		log_amx("*Create Ban Menu");
	}
	
	if(get_pcvar_num(gcvarAMXMODMENU))
		server_cmd("amx_addmenuitem ^"Ban Config^" ^"amx_bancfg_pmenu^" ^"hu^" ^"extreme_bancfg.amxx^"");
	
	return PLUGIN_CONTINUE;
}

public thinkCheckBans(ent){
	if(gbDebug){
		log_amx("*Check bans");
	}
	new iNow=get_systime();
	new iUnBanTime;
	for(new i=0;i<ArraySize(gUnBanTime);i++){
		iUnBanTime=ArrayGetCell(gUnBanTime, i);
		if( iUnBanTime < iNow){
			unBan(i, iUnBanTime);
		}
	}
	entity_set_float(ent, EV_FL_nextthink, halflife_time()+60.0 );
}
public client_putinserver(id){
	/*if(get_pcvar_num(gcvarSave))
		client_cmd(id, "exec %s.cfg;clear", CFG);*/
	if(gbDebug){
		log_amx("[VAL] Client put: %d",id);
	}
	new szCode[32]
	get_user_info(id, FIELD, szCode, 31);
	if(gbDebug){
		log_amx("[VAL] Client#%d Code: %s",id,szCode);
	}
	if(szCode[0]==0){
		return;
	}
	new iCodeId=get_code_id(szCode);
	if(gbDebug){
		log_amx("[VAL] Client#%d ID on list: %d",id,iCodeId);
	}
	if(iCodeId==-1) return;
	new iUnBanTime=ArrayGetCell(gUnBanTime, iCodeId);
	if(gbDebug){
		log_amx("[VAL] Client#%d UnBanTime: %d, Now: %d",id,iUnBanTime,get_systime());
	}
	if(iUnBanTime < get_systime() && iUnBanTime!=0){
		unBan(iCodeId, iUnBanTime);
		return;
	}
	if(gbDebug){
		log_amx("*TaskKick Client#%d",id);
	}
	new param[2];
	param[0]=iCodeId;
	param[1]=iUnBanTime;
	set_task(1.0, "delay",TASK_DELAY+id, param, 2)
	
}
public delay(const param[], tid){
	new iCodeId=param[0];
	new iUnBanTime=param[1];
	new id=tid-TASK_DELAY;
	
	new szReason[32];
	ArrayGetString(gReasons, iCodeId, szReason ,31);
	
	if(gbDebug){
		log_amx("*Read reason of Kick Client#%d: %s",id, szReason);
	}
	
	new iBanTime=ArrayGetCell(gTimeStamp, iCodeId);
	kick(id, szReason, (iUnBanTime-iBanTime)/60,"", true);
}
public cmd_amx_bancfg(id, level, cid){
	if(!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED;
	new szTarget[32], iTarget;
	read_argv(1, szTarget, 31);
	iTarget=cmd_target(id, szTarget, CMDTARGET_OBEY_IMMUNITY | CMDTARGET_NO_BOTS | CMDTARGET_ALLOW_SELF);
	if(is_user_connected(iTarget)){
		
		new szName[32];
		get_user_name(iTarget, szName, 31);
		
		if(is_user_bot(iTarget)){
			console_print(id, "%L",id,"CANT_PERF_BOT",szName);
			return PLUGIN_HANDLED;
		}
		
		new iTime, szTime[32], szReason[32];
		read_argv(2, szTime, 31);
		iTime=str_to_num(szTime);
		
		read_argv(3, szReason, 31);
		if(szReason[0]==0)
			copy(szReason, 32, "bez powodu");
			
		
		new szCode[32];
		formatex(szCode, 31, "%d", giCode++);
		
		new iNowTime=get_systime();
		new iTime2=(iTime)?iNowTime+60*iTime:0;
		
		saveBan(ArraySize(gCodes), szCode, szName,iNowTime, iTime2, szReason);
		
		ArrayPushString(gCodes, szCode);
		ArrayPushString(gNames, szName);
		ArrayPushString(gReasons, szReason);
		ArrayPushCell(gTimeStamp, iNowTime);
		ArrayPushCell(gUnBanTime, iTime2);
		
		client_cmd(iTarget, "developer 1;wait;%s %s ^"%s^";developer 0",szSth, FIELD, szCode);
		new szName2[32];
		get_user_name(id, szName2, 31);
		kick(iTarget, szReason, iTime,szName2);
		/*if(get_pcvar_num(gcvarSave))
			client_cmd(iTarget, "writecfg %s",CFG);*/
		//client_cmd(iTarget, "clear");
		
		
		
		// Display the message to all clients
		new msg[256];
		new len;
		new maxpl = get_maxplayers();
		for (new i = 1; i <= maxpl; i++)
		{
			if (is_user_connected(i) && !is_user_bot(i))
			{
				len = formatex(msg, charsmax(msg), "%L", i, "BAN");
				len += formatex(msg[len], charsmax(msg) - len, " %s ", szName);
				if (iTime)
				{
					formatex(szTime, 31, "%d", iTime);
					len +=formatex(msg[len], charsmax(msg) - len, "%L", i, "FOR_MIN", szTime);
				}
				else
				{
					len +=formatex(msg[len], charsmax(msg) - len, "%L", i, "PERM");
				}
				if (strlen(szReason) > 0)
				{
					formatex(msg[len], charsmax(msg) - len, " (%L: %s)", i, "REASON", szReason);
				}
				show_activity_id(i, id, szName2, msg);
			}
		}
		
		
		
		new szAuth[32];
		get_user_authid(iTarget, szAuth, 31);
		log_message("BanCfg2: ^"%s<%d><%s><>^" was kicked by ^"Console^" (reason ^"%s^")",
		szName, get_user_userid(iTarget), szAuth, szReason);
		
		saveGICODE();
	}
	return PLUGIN_HANDLED;
}
public cmd_amx_unbancfg(id, level, cid){
	if(!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;
	if(read_argc()==1){
		cmd_amx_list_bancfg(id, level, cid);
		return PLUGIN_HANDLED;
	}
	new szCode[32];
	read_argv(1, szCode, 31);
	new iCodeId=get_code_id(szCode);
	if(iCodeId==-1){
		console_print(id, "[BanCFG] Bledny kod, przeszukaj liste: 'amx_list_bancfg'");
	}else{
		new szName[32];
		ArrayGetString(gNames, iCodeId, szName, 31);
		unBan(iCodeId);
		console_print(id, "[BanCFG] Gracz %s zostal odbanowany", szName);
		new szName2[32];
		get_user_name(id, szName2, 31);
		show_activity_key("ADMIN_UNBAN_1", "ADMIN_UNBAN_2", szName2, szName);
	}
	return PLUGIN_HANDLED;
}
public cmd_amx_list_bancfg(id, level, cid){
	if(!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;
	new iBanTime, szBanTime[32];
	new iUnBanTime, szUnBanTime[32];
	new szName[32], szReason[32];
	new iMax=ArraySize(gCodes);
	if(iMax==0){
		console_print(id, "[BanCFG] Brak banow");
		return PLUGIN_HANDLED;
	}
	console_print(id, "----------------UWAGA-----------------");
	console_print(id, "Lp to numer porzadkowy na liscie");
	console_print(id, "kod (!) to wartosc potrzebna do amx_unbancfg");
	console_print(id, "---------------------------------------------");
	console_print(id, " Lp | kod | nick | powod | data bana | data unbana");
	console_print(id, "---------------------------------------------");
	new szCode[32];
	
	new szStart[10];
	read_argv(1, szStart, 9);
	new iStart=str_to_num(szStart)-1;
	if(iStart<0 || iStart>=iMax)
		iStart=0;
	new iStop=iStart+BANS_PER_PAGE;
	if(iStop>=iMax)
		iStop=iMax-1;
	for(new i=iStart;i<=iStop;i++){
		ArrayGetString(gNames, i, szName, 31);
		ArrayGetString(gReasons, i, szReason, 31);
		ArrayGetString(gCodes, i, szCode, 31);
		iBanTime=ArrayGetCell(gTimeStamp, i);
		format_time(szBanTime, 31, "%m/%d/%Y %H:%M:%S", iBanTime);
		iUnBanTime=ArrayGetCell(gUnBanTime, i);
		
		if(iUnBanTime)
			format_time(szUnBanTime, 31, "%m/%d/%Y %H:%M:%S", iUnBanTime);
		else
			formatex(szUnBanTime, 31, "Nigdy");
		console_print(id, " %d | %s | %s | %s |^n^t^t %s |^n^t^t %s",i+1,szCode, szName, szReason, szBanTime, szUnBanTime);
	}
	console_print(id, "---------------------------------------------");
	console_print(id, "^t%L", id, "HELP_ENTRIES", iStart+1, iStop+1, iMax);
	new szCmd[32];
	read_argv(0, szCmd, 32);
	iStop+=2;
	if(iStop<=iMax){
		console_print(id, "Uzyj '%s %d', aby zobaczy wiecej ",szCmd,iStop);
	}
	console_print(id, "---------------------------------------------");
	return PLUGIN_HANDLED;
}
//UnBan
unBan(index, utime=-1){
	if(utime==0) return;
	ArrayDeleteItem(gCodes, index);
	ArrayDeleteItem(gNames, index);
	ArrayDeleteItem(gReasons, index);
	ArrayDeleteItem(gTimeStamp, index);
	ArrayDeleteItem(gUnBanTime, index);
	saveBans();
}
//id`s
get_code_id(const szCode[32]){
	new szCode2[32];
	for(new i=0;i<ArraySize(gCodes);i++){
		ArrayGetString(gCodes, i, szCode2, 31);
		if(equal(szCode, szCode2))
			return i;
	}
	return -1;
}
saveGICODE(){
	new szCode[32];
	formatex(szCode, 31,"%d", giCode);
	write_file(gszFile2,szCode,0);
}
get_sid(const szCfgDir[], szSID[20]){
	new szFile[128];
	formatex(szFile, 127, "%s/cfgban/field.txt",szCfgDir);
	if(file_exists(szFile)){
		new iLen;
		read_file(szFile, 0, szSID, 19, iLen);
	}else{
		new szIP[33], iIP;
		get_user_ip(0, szIP, 32);
		replace_all(szIP, 32, ".","");
		
		new szPort[7], iPort;
		strtok(szIP, szIP, 27, szPort, 6, ':');
		
		new offset=strlen(szIP)-7;
		iIP=str_to_num(szIP[offset]);
		iPort=str_to_num(szPort);
		
		formatex(szSID, 19,"%s%d",FIELD_PREFIX, (iIP+iPort)%1234);
		write_file(szFile, szSID, 0);
	}
}
//Saving
public saveBans(){
	if(file_exists(gszFile))
		delete_file(gszFile);
	new szCode[32], iNowTime, iTime, szReason[32];
	new szName[32];
	for(new i=0;i<ArraySize(gUnBanTime);i++){
		ArrayGetString(gCodes, i, szCode, 31);
		ArrayGetString(gNames, i, szName, 31);
		ArrayGetString(gReasons, i, szReason , 31);
		iNowTime=ArrayGetCell(gTimeStamp, i);
		iTime=ArrayGetCell(gUnBanTime, i);
		saveBan(i, szCode,szName, iNowTime, iTime, szReason);
	}
}
saveBan(iLine, const szCode[],const szName[],iNowTime, iTime, const szReason[]){
	new text[128];
	formatex(text, 127, "^"%s^" ^"%s^" ^"%d^" ^"%d^" ^"%s^"", szCode,szName,iNowTime, iTime, szReason)
	write_file(gszFile,text, iLine);
}
public realKick(tid){
	server_cmd("kick #%d Masz bana. Sprawdz konsole !", get_user_userid(tid-TASK_RKICK));
}
//kicking
kick(id, const szReason[], iTime,const szAdminName[], bool:connecting=false){
	if(gbDebug){
		log_amx("*Kick Client#%d: %s",id, szReason);
	}
	new userid2 = get_user_userid(id);
	new temp[164], banned[16];
	formatex(banned, 15, "%d", iTime);
	
	if (iTime)
			formatex(temp, 163, "%L", id, "FOR_MIN", banned);
		else
			formatex(temp, 163, "%L", id, "PERM");
	new cFirstChar=connecting?gszBuffer2[0]:gszBuffer[0];
	if(cFirstChar){
		
		new szTemp[512], szBuff[128];
		
		new iMax=charsmax(szTemp);
		new iMax2=charsmax(szBuff);
		
		copy(szTemp, charsmax(szTemp),connecting?gszBuffer2:gszBuffer);

		new authid[32], pip[32], szName[32];
		get_user_authid(id, authid, 31);
		get_user_ip(id, pip, 31);
		get_user_name(id, szName, 31);
		
		replace_all(szTemp, iMax,"[BAN_REASON]",szReason);
		replace_all(szTemp, iMax,"[BAN_TIME]",temp);
		
		replace_all(szTemp, iMax,"[PLAYER_NAME]",szName);
		replace_all(szTemp, iMax,"[PLAYER_AUTHID]",authid);
		replace_all(szTemp, iMax,"[PLAYER_IP]",pip);
		
		replace_all(szTemp, iMax,"[ADMIN_NAME]",szAdminName);
		
		
		while(contain(szTemp,"^n")>=0){
			strtok(szTemp, szBuff, iMax2, szTemp, iMax, '^n')
			console_print(id, "%s", szBuff);
		}
		console_print(id, "%s", szTemp);
		if(connecting)
			server_cmd("kick #%d Masz bana. Sprawdz konsole !",userid2);
		else
			set_task(get_pcvar_float(gcvarDelay), "realKick",TASK_RKICK+id);
	}else{
		
		format(banned, 15, "%L",id, "BANNED")

		new authid2[32];
		get_user_authid(id, authid2, 31)
		if (szReason[0])
			server_cmd("kick #%d ^"%s (%s %s)^"", userid2, szReason, banned, temp);
		else
			server_cmd("kick #%d ^"%s %s^"", userid2, banned, temp);
	}
}
//Menu
buildMenu(){
	new iBuf,szBuf[REASON_LEN];
	for(new i=0;i<ArraySize(g_ArrayTimes);i++){
		iBuf=ArrayGetCell(g_ArrayTimes,i);
		if(iBuf==0)
			copy(szBuf,9,"Perm.");
		else{
			formatex(szBuf,13,"%d min",iBuf);
		}
		menu_additem(mTime, szBuf, "Time", MENU_ACCESS);
	}
	menu_additem(mTime, "[Wlasny]", "Time", MENU_ACCESS);
	for(new i=0;i<ArraySize(g_ArrayReasons);i++){
		ArrayGetString(g_ArrayReasons,i,szBuf,REASON_LEN);
		menu_additem(mReason, szBuf, "Reason", MENU_ACCESS);
	}
	menu_additem(mReason, "[Wlasny]", "Reason", MENU_ACCESS);
}
public cmd_amx_banshot_menu(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;
	new szArg1[35];
	read_argv(1,szArg1,34);
	new target_id=cmd_target(id,szArg1);
	g_Target[id]=target_id;
	if(target_id==0){
		return PLUGIN_HANDLED;
	}
	menu_display(id, mTime);
	return PLUGIN_HANDLED;
}
public cmd_amx_banshot_pmenu(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED;
	menu_display(id,buildPlayersMenu());
	return PLUGIN_HANDLED;
}
//*****************//
//***PlayersMenu***//
//*****************//
buildPlayersMenu(){
	new mPlayers = menu_create("Players", "mh_Players"); // Menu Players
	new id,szUserName[33];
	get_players(g_Players, g_playerCount);
	for (new i=0; i<g_playerCount; i++){
		id = g_Players[i];
		get_user_name(id,szUserName,32);
		menu_additem(mPlayers, szUserName, "", MENU_ACCESS, mcbPlayers);
	}
	return mPlayers;
}
public mh_Players(id, menu, item){
	if(item<0)
		return;
	client_cmd(id,"amx_bancfg_menu #%d",get_user_userid(g_Players[item]));
}
public mcb_Players(id, menu, item) {
	if(get_user_flags(g_Players[item])&ADMIN_IMMUNITY)
		return ITEM_DISABLED;
	return ITEM_ENABLED;
}
//*****************//
//***OtherMenus****//
//*****************//
public mh_Time(id, menu, item){
	if(item<0)
		return;
	if(item==ArraySize(g_ArrayTimes)){
		client_cmd(id,"messagemode bancfg_custom_time");
		return;
	}
	g_SelectedTime[id]=ArrayGetCell(g_ArrayTimes,item);
	menu_display(id, mReason);
}
public mh_Reason(id, menu, item){
	if(item<0)
		return;
	if(item==ArraySize(g_ArrayReasons)){
		client_cmd(id,"messagemode bancfg_custom_reason");
		return;
	}
	new szReason[REASON_LEN];
	ArrayGetString(g_ArrayReasons,item,szReason,REASON_LEN);
	banShot(id,szReason);
}
//*****************//
//*******CMDS******//
//*****************//
public cmd_custom_time(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;
	if(g_Target[id]==0){
		client_print(id,print_center,"Najpierw wybierz gracza");
		return PLUGIN_HANDLED;
	}
	new szArg1[10];
	read_argv(1,szArg1,9);
	g_SelectedTime[id]=str_to_num(szArg1);
	menu_display(id, mReason);
	return PLUGIN_HANDLED;
}
public cmd_custom_reason(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;
	if(g_Target[id]==0){
		client_print(id,print_center,"Najpierw wybierz gracza");
		return PLUGIN_HANDLED;
	}
	new szArg1[REASON_LEN];
	read_argv(1,szArg1,REASON_LEN-1);
	banShot(id,szArg1);
	return PLUGIN_HANDLED;
}
public banShot(id,szReason[REASON_LEN]){
	client_cmd(id,"amx_bancfg #%d %d ^"%s^"",get_user_userid(g_Target[id]),g_SelectedTime[id],szReason);
	g_Target[id]=0;
}